from numpy import *

def get_g():
  G = 1.0
  return G

def get_N():
  N=4
  return N

def Gamma_Deltax(G,rho,kappa) :
#   assume  Nx=N/2,  spin up: [:Nx]; spin down[Nx:]
  N=shape(rho)[0]; Nx=N/2
  Gamma=array([[0.0j]*N]*N)
  Delta=Gamma*1.0
  for i in range(Nx) :
    for j in range(Nx): 
     if i != j :
      Delta[i,i+Nx] +=  -0.5*G*(kappa[j,j+Nx]-kappa[j+Nx,j])
  Delta += - transpose(Delta)
  return Gamma,Delta

def Gamma_Delta(rho,kappa) :
#   assume  Nx=N/2,  spin up: [:Nx]; spin down[Nx:]
  N=shape(rho)[0]; Nx=N/2
  Gamma=array([[0.0j]*N]*N)
  Delta=Gamma*1.0
  G = get_g()
  for i in range(Nx) :
    for j in range(Nx): 
     if i != j :
      Delta[i,i+Nx] +=  -0.5*G*(kappa[j,j+Nx]-kappa[j+Nx,j])
  Delta += - transpose(Delta)
  return Gamma,Delta

def v_me(m1,m2,m3,m4):
  G = get_g()
  s1 = 0.0; s2 = 0.0
  if m1+2 == m2 : s1= 1.0
  if m1 == m2+2 : s1 = -1.0
  if m3+2 == m4 : s2 = 1.0
  if m3 == m4+2 : s2 = -1.0
  if m1+m2 == m3+m4 : s1 = 0.0
  return -G*s1*s2

   
def mk_esp() :
  ediag = [-0.25,0.25]
  N=4; Nx=N/2
  esp = array([[0.0]*N]*N)
  for i in range(Nx) :
    esp[i,i] = ediag[i]
    esp[i+Nx,i+Nx] = ediag[i] 
  return esp
